import java.util.ArrayList;
public class Sortieren {

    public static void quickSort (ArrayList<Comparable> aktListe) {
        quickSort (aktListe, 0, aktListe.size()-1);
    }

    public static void quickSort (ArrayList<Comparable> aktListe, int erstesEl, int letztesEl) {
        int neuesErstesEl = erstesEl;
        int neuesLetztesEl = letztesEl;
        //Mittleres Element finden
        Comparable mittleresEl = aktListe.get((erstesEl + letztesEl) / 2);
        
        //Algorithmus
        do{
            //Links von der Mitte ist alles kleiner?   
            while (aktListe.get(neuesErstesEl).compareTo(mittleresEl) < 0) 
                neuesErstesEl++;
            //Rechts von der Mitte ist alles grer?
            while (aktListe.get(neuesLetztesEl).compareTo(mittleresEl) > 0) 
                neuesLetztesEl--;
            //Vertauschen
            if (neuesErstesEl <= neuesLetztesEl) {
                tauschen(aktListe,neuesErstesEl,neuesLetztesEl);
                neuesErstesEl++;
                neuesLetztesEl--;
            }
        } while (neuesErstesEl < neuesLetztesEl);
        //Rekursiver Aufruf
        if (neuesLetztesEl > erstesEl) quickSort (aktListe,erstesEl,neuesLetztesEl);
        if (neuesErstesEl < letztesEl) quickSort (aktListe,neuesErstesEl,letztesEl);
    }

    public static void tauschen(ArrayList<Comparable> list, int idx1, int idx2)
    {
        Comparable zwischenSpeichern = list.get(idx1);
        list.set(idx1, list.get(idx2));
        list.set(idx2, zwischenSpeichern);
    }}
