import javax.swing.JFileChooser;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
 
public class OeffnenDialog {
    public static ArrayList<String> getData() {
        ArrayList<String> ergebnis = new ArrayList<String>();
        
        // JFileChooser-Objekt erstellen
        JFileChooser chooser = new JFileChooser();
        // Dialog zum Oeffnen von Dateien anzeigen
        int rueckgabeWert = chooser.showOpenDialog(null);
        
        String dateiName = "";
        
        /* Abfrage, ob auf "ffnen" geklickt wurde */
        if(rueckgabeWert == JFileChooser.APPROVE_OPTION) {
            // Ausgabe der ausgewaehlten Datei
            //dateiName = chooser.getSelectedFile().getName();
            dateiName = chooser.getSelectedFile().getAbsolutePath();
            //System.out.println("Die zu ffnende Datei ist: " + dateiName);
        }
        
        if (dateiName.length()>0) {
        
            try {
                BufferedReader in = new BufferedReader(new FileReader(dateiName));
                String zeile = null;
                while ((zeile = in.readLine()) != null) {
                    //System.out.println("Gelesene Zeile: " + zeile);
                    ergebnis.add(zeile);
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return ergebnis;
    }
}
